import java.awt.*;

public abstract class Plant
{
    /* Klassvariabler - Egenskaper som gller fr alla vxter. */
    protected static final int DEF_LEAVS = 7;
    protected static final double DEF_HEIGHT = 5;
    protected static final double DEF_SIZE = 15;


    /* Instansvariabler - Egenskaper som skiljer sig mellan vxterna. */
    private Color color;
    private int leavs;
    private double height;
    private double size;
    private Smell smell;
    private int x;
    private int y;

    /* Konstruktor */
    public Plant(Color color, int leavs, double height,
                 double size, Smell smell)
    {
        this.color = color;
        this.leavs = leavs;
        this.height = height;
        this.size = size;
        this.smell = smell;
        x = (int)(Math.random() * 725 + 25);
        y = (int)(Math.random() * 525 + 25);
    }


    /* Selektorer (selektorer r ocks metoder..) */

    public Color getColor()
    {
        return color;
    }

    public int getLeavs()
    {
        return leavs;
    }

    public double getHeight()
    {
        return height;
    }

    public double getSize()
    {
        return size;
    }

    public Smell getSmell()
    {
        return smell;
    }

    public int getX()
    {
        return x;
    }

    public int getY()
    {
        return y;
    }

    public abstract double getGrowthFactor();


    /* Metoder - Frdigheter */

    public void consume(double energy)
    {
        height += energy * getGrowthFactor();
    }

    public abstract void paint(Graphics g);
}