import java.awt.*;

public class Weed extends Plant
{
    private static double growthFactor = 0.60;

    /* Konstruktorer */
    public Weed()
    {
        super(new Color((int)(Math.random() * 200),
                        (int)(Math.random() * 200),
                        (int)(Math.random() * 200)),
              ((int)(Math.random() * 2)) * 2 + 3,
              Math.random() * 60 + 20,
              Math.random() * 50 + 5,
              Smell.AWFUL);
    }

    public Weed(Color c, double size)
    {
        super(c, DEF_LEAVS, DEF_HEIGHT, size, Smell.STRANGE);
    }

    public Weed(Color color, int leavs, double height,
                double size, Smell smell)
    {
        super(color, leavs, height, size, smell);
    }

    /* Metoder - Frdigheter */

    public double getGrowthFactor()
    {
        return growthFactor;
    }

    public void consume(Fluid f)
    {
        consume(f.getDensity());
    }

    public void paint(Graphics g)
    {
        int x = getX();
        int y = getY();
        g.setColor(getColor());

        for (int i = 0; i < getLeavs(); i++) {
            double xOrign = x + Math.sin(i * 2 * Math.PI / getLeavs()) *
                (getSize() * 0.75);
            double yOrign = y + Math.cos(i * 2 * Math.PI / getLeavs()) *
                (getSize() * 0.75);

            int xCords[] = { (int)(xOrign +
                                   Math.sin((1 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()),
                             (int)(xOrign +
                                   Math.sin((2 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()),
                             (int)(xOrign +
                                   Math.sin((3 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()) };
            // Syntax: int f[] = { 6, 5, 8 }

            int yCords[] = { (int)(yOrign +
                                   Math.cos((1 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()),
                             (int)(yOrign +
                                   Math.cos((2 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()),
                             (int)(yOrign +
                                   Math.cos((3 * 2 * Math.PI) / 3 +
                                            (i * 2 * Math.PI) / getLeavs() +
                                            1.05) * getSize()) };

            g.fillPolygon(xCords, yCords, 3);
        }
    }

    public String toString()
    {
        return "I am a " + getHeight() +
            "cm tall weed and I smell " + getSmell() +
            ", hahahaa!";
    }
}
